searchNodes=[{"doc":"Namespace only and exposing version","ref":"ExAequo.html","title":"ExAequo","type":"module"},{"doc":"Used by the xtra mix task to generate the latest version in the docs, but also handy for client applications for quick exploration in iex .","ref":"ExAequo.html#version/0","title":"ExAequo.version/0","type":"function"},{"doc":"## Support for the 256 ANSI and full RGB colors N.B. Does, of course, respect the usage of the $NO_COLOR variable The most basic approach is to use the generated escape sequences directly in your code, e.g. IO . puts ( ExAequo.Color . rgb ( 250 , 148 , 13 ) &lt;&gt; &quot;Brownish Orange&quot; &lt;&gt; ExAequo.Color . reset ) rgb The generated escape codes would be: iex(1)&gt; rgb ( 250 , 148 , 13 ) &quot; \\e [38;2;250;148;13m&quot; iex(2)&gt; reset ( ) &quot; \\e [0m&quot; format But like IO.ANSI a convenience function called format is available iex(3)&gt; format ( [ &quot;Hello&quot; , &quot;World&quot; ] ) [ &quot;Hello&quot; , &quot;World&quot; ] As one can see it is tailor made for IO.puts and may be converted into a string by means of IO.chardata_to_string , this conversion can also be done by format itself iex(4)&gt; format ( [ &quot;Hello&quot; , &quot;World&quot; ] , to_string : true ) &quot;HelloWorld&quot; putc A shortcut for color_definition_list |&gt; format |&gt; IO . puts RGB In order to get colors into the mix we can use, atoms (for named colors or instructions like reset) or triples for RGB colors iex(5)&gt; format ( [ { 100 , 20 , 150 } , &quot;Deep Purple (pun intended)&quot; , :reset ] ) [ &quot; \\e [38;2;100;20;150m&quot; , &quot;Deep Purple (pun intended)&quot; , &quot; \\e [0m&quot; ] 8 Color Space And here are some nice names, which shall work on all terminals iex(6)&gt; format ( [ :red , &quot;red&quot; , :blue , &quot;blue&quot; ] ) [ &quot; \\e [31m&quot; , &quot;red&quot; , &quot; \\e [34m&quot; , &quot;blue&quot; ] Oftentimes you will pass a variable to format and not a literal array, then the usage of the reset: true option might come in handy iex(7)&gt; some_values = [ :azure1 , &quot;The sky?&quot; ] ...(7)&gt; format ( some_values , reset : true , to_string : true ) &quot; \\e [38;2;240;255;255mThe sky? \\e [0m&quot; 256 Colors iex(8)&gt; format ( [ :color242 , :color142 , :color42 ] ) [ &quot; \\e [38;5;242m&quot; , &quot; \\e [38;5;142m&quot; , &quot; \\e [38;5;42m&quot; ] Escript ls_colors Test some colors ls_colors :red Red :reset 100,20,150 Deep Purple Show some colors ls_colors -l|--list red_range green_range blue_range","ref":"ExAequo.Color.html","title":"ExAequo.Color","type":"module"},{"doc":"","ref":"ExAequo.Color.html#format/2","title":"ExAequo.Color.format/2","type":"function"},{"doc":"","ref":"ExAequo.Color.html#putc/2","title":"ExAequo.Color.putc/2","type":"function"},{"doc":"","ref":"ExAequo.Color.html#reset/0","title":"ExAequo.Color.reset/0","type":"function"},{"doc":"","ref":"ExAequo.Color.html#rgb/1","title":"ExAequo.Color.rgb/1","type":"function"},{"doc":"","ref":"ExAequo.Color.html#rgb/3","title":"ExAequo.Color.rgb/3","type":"function"},{"doc":"","ref":"ExAequo.Color.Escript.html","title":"ExAequo.Color.Escript","type":"module"},{"doc":"","ref":"ExAequo.Color.Escript.html#main/1","title":"ExAequo.Color.Escript.main/1","type":"function"},{"doc":"ExAequo.Enum offers some extension functions for Elixir's Enum module Grouped Accumulation Groupes accumulated values of an Enum according to a function that indicates if two consequent items are of the same kind and if so how to accumulate their two values. The grouped_reduce function returns the groupes in reverse order, as, during traversal of lists quite often reversing the result of the classical &quot;take first and push a function of it to the result&quot; pattern cancels out. An optional, reverse: true keyword option can be provided to reverse the final result for convenience. iex(0)&gt; add_same = fn { x , a } , { y , b } -&gt; ...(0)&gt; cond do ...(0)&gt; x == y -&gt; { :cont , { x , a + b } } ...(0)&gt; true -&gt; { :stop , nil } end end ...(0)&gt; E . grouped_reduce ( ...(0)&gt; [ { :a , 1 } , { :a , 2 } , { :b , 3 } , { :b , 4 } ] , add_same ) [ { :b , 7 } , { :a , 3 } ] The grouped_inject function behaves almost identically to grouped_reduce , however an initial value is provided. iex(1)&gt; sub_same = fn { x , a } , { y , b } -&gt; ... ( 1 ) &gt; cond do ...(1)&gt; x == y -&gt; { :cont , { x , a - b } } ...(1)&gt; true -&gt; { :stop , nil } ...(1)&gt; end ...(1)&gt; end ...(1)&gt; E . grouped_inject ( ...(1)&gt; [ { :a , 1 } , { :b , 2 } , { :b , 2 } , { :c , 2 } , { :c , 1 } , { :c , 1 } ] , ...(1)&gt; { :a , 43 } , sub_same , reverse : true ) [ a : 42 , b : 0 , c : 0 ]","ref":"ExAequo.Enum.html","title":"ExAequo.Enum","type":"module"},{"doc":"","ref":"ExAequo.Enum.html#t:grouped_accumulator/2","title":"ExAequo.Enum.grouped_accumulator/2","type":"type"},{"doc":"ExAequo.File","ref":"ExAequo.File.html","title":"ExAequo.File","type":"module"},{"doc":"","ref":"ExAequo.File.html#files/1","title":"ExAequo.File.files/1","type":"function"},{"doc":"expands wc and zips each matching file into a list of {String.t, File.Stat.t}","ref":"ExAequo.File.html#files_with_stat/1","title":"ExAequo.File.files_with_stat/1","type":"function"},{"doc":"read a file into lines iex(0)&gt; readlines ( Path . join ( ~W[test fixtures a_simple_file.txt] ) ) [ &quot;Line 1&quot; , &quot;Line two&quot; , &quot; Una terza linea&quot; ]","ref":"ExAequo.File.html#readlines/1","title":"ExAequo.File.readlines/1","type":"function"},{"doc":"expands wc and zips each matching file into a list of {String.t, File.Stat.t} , then filters only the files from today","ref":"ExAequo.File.html#today/1","title":"ExAequo.File.today/1","type":"function"},{"doc":"","ref":"ExAequo.File.html#t:date_tuple/0","title":"ExAequo.File.date_tuple/0","type":"type"},{"doc":"","ref":"ExAequo.File.html#t:lstat_result/0","title":"ExAequo.File.lstat_result/0","type":"type"},{"doc":"","ref":"ExAequo.File.html#t:param_type/0","title":"ExAequo.File.param_type/0","type":"type"},{"doc":"","ref":"ExAequo.File.html#t:params_t/0","title":"ExAequo.File.params_t/0","type":"type"},{"doc":"Tools to facilitate dispatching on keyword parameters, used in contexts like the following @defaults [ a : 1 , b : false ] # Keyword or Map def some_fun ( ... , options \\ [ ] ) # options again can be a Keyword or Map { a , b } = tuple_from_params ( @defaults , options , [ :a , :b ] ) Merging defaults and actual parameters Its most useful feature is that you will get a map whatever the mixtures of maps and keywords the input was iex(0)&gt; merge_params ( [ ] ) %{ } iex(1)&gt; merge_params ( [ a : 1 ] , %{ b : 2 } ) %{ a : 1 , b : 2 } iex(2)&gt; merge_params ( %{ a : 1 } , [ a : 2 , b : 2 ] ) %{ a : 2 , b : 2 } Strict merging Not implemented yet Extracting params from the merged defaults and actuals iex(3)&gt; defaults = [ foo : false , depth : 3 ] ...(3)&gt; tuple_from_params ( defaults , %{ foo : true } , [ :foo , :depth ] ) { true , 3 } As defaults are required a missing parameter will raise an Error iex(4)&gt; try do ...(4)&gt; tuple_from_params ( [ ] , [ foo : 1 ] , [ :bar ] ) ...(4)&gt; rescue ...(4)&gt; KeyError -&gt; :caught ...(4)&gt; end :caught Alternatively on can extract a map iex(5)&gt; map_from_params ( [ ] , [ hello : &quot;world&quot; ] , [ :hello ] ) %{ hello : &quot;world&quot; }","ref":"ExAequo.KeywordParams.html","title":"ExAequo.KeywordParams","type":"module"},{"doc":"This is the 2 param form which is identical to an empty default map iex(6)&gt; map_from_params ( %{ a : 1 , b : 2 } , [ :a ] ) %{ a : 1 }","ref":"ExAequo.KeywordParams.html#map_from_params/2","title":"ExAequo.KeywordParams.map_from_params/2","type":"function"},{"doc":"","ref":"ExAequo.KeywordParams.html#map_from_params/3","title":"ExAequo.KeywordParams.map_from_params/3","type":"function"},{"doc":"","ref":"ExAequo.KeywordParams.html#merge_params/1","title":"ExAequo.KeywordParams.merge_params/1","type":"function"},{"doc":"","ref":"ExAequo.KeywordParams.html#merge_params/2","title":"ExAequo.KeywordParams.merge_params/2","type":"function"},{"doc":"This is the 2 param form which is identical to an empty default map iex(7)&gt; tuple_from_params ( %{ a : 1 , b : 2 } , [ :b , :a ] ) { 2 , 1 }","ref":"ExAequo.KeywordParams.html#tuple_from_params/2","title":"ExAequo.KeywordParams.tuple_from_params/2","type":"function"},{"doc":"","ref":"ExAequo.KeywordParams.html#tuple_from_params/3","title":"ExAequo.KeywordParams.tuple_from_params/3","type":"function"},{"doc":"","ref":"ExAequo.KeywordParams.html#t:date_tuple/0","title":"ExAequo.KeywordParams.date_tuple/0","type":"type"},{"doc":"","ref":"ExAequo.KeywordParams.html#t:lstat_result/0","title":"ExAequo.KeywordParams.lstat_result/0","type":"type"},{"doc":"","ref":"ExAequo.KeywordParams.html#t:param_type/0","title":"ExAequo.KeywordParams.param_type/0","type":"type"},{"doc":"","ref":"ExAequo.KeywordParams.html#t:params_t/0","title":"ExAequo.KeywordParams.params_t/0","type":"type"},{"doc":"Extending Elixir's Path module with some useful functions","ref":"ExAequo.Path.html","title":"ExAequo.Path","type":"module"},{"doc":"iex(0)&gt; basename_without_ext ( &quot;a/b/c.txt&quot; ) &quot;c&quot; iex(1)&gt; basename_without_ext ( &quot;a/b/c.txt.eex&quot; ) &quot;c.txt&quot; iex(2)&gt; basename_without_ext ( &quot;a/b/c&quot; ) &quot;c&quot;","ref":"ExAequo.Path.html#basename_without_ext/1","title":"ExAequo.Path.basename_without_ext/1","type":"function"},{"doc":"iex(3)&gt; fullname_without_ext ( &quot;a/b/c.txt&quot; ) &quot;a/b/c&quot; iex(4)&gt; fullname_without_ext ( &quot;a/b/c.txt.eex&quot; ) &quot;a/b/c.txt&quot; iex(5)&gt; fullname_without_ext ( &quot;a/b/c&quot; ) &quot;a/b/c&quot; iex(6)&gt; fullname_without_ext ( &quot;/c&quot; ) &quot;/c&quot;","ref":"ExAequo.Path.html#fullname_without_ext/1","title":"ExAequo.Path.fullname_without_ext/1","type":"function"},{"doc":"","ref":"ExAequo.Path.html#t:date_tuple/0","title":"ExAequo.Path.date_tuple/0","type":"type"},{"doc":"","ref":"ExAequo.Path.html#t:lstat_result/0","title":"ExAequo.Path.lstat_result/0","type":"type"},{"doc":"","ref":"ExAequo.Path.html#t:param_type/0","title":"ExAequo.Path.param_type/0","type":"type"},{"doc":"","ref":"ExAequo.Path.html#t:params_t/0","title":"ExAequo.Path.params_t/0","type":"type"},{"doc":"This module allows to parse Command Line Arguments with attached semantics, that is Constraints and Conversions Errors from the SimpleClaParser are returned verbatim iex(1)&gt; parse ( ~W[a:] ) { :error , %{ args : [ ] , kwds : %{ } , error : &quot;Missing value for keyword arg a!&quot; } } Empty args might be ok iex(2)&gt; parse ( [ ] ) { :ok , %{ args : [ ] , kwds : %{ } } } or they might not iex(3)&gt; parse ( [ ] , required : [ :level ] ) { :error , %{ args : [ ] , kwds : %{ } , errors : [ missing_required_kwd : :level ] } } Constraints can also do conversions iex(4)&gt; parse ( ~W[value: 42] , required : [ value : :int ] ) { :ok , %{ args : [ ] , kwds : %{ value : 42 } } } and if they fail we get an error iex(5)&gt; parse ( ~W[value: 42a] , required : [ value : :int ] ) { :error , %{ args : [ ] , kwds : %{ value : &quot;42a&quot; } , errors : [ { :bad_constraint_int , :value , &quot;42a&quot; } ] } } constraints can also be defined for optional values iex(6)&gt; parse ( ~W[value: 42] , optional : [ value : :int ] ) { :ok , %{ args : [ ] , kwds : %{ value : 42 } } } and then it is ok, not to provide them iex(7)&gt; parse ( [ ] , optional : [ value : :int ] ) { :ok , %{ args : [ ] , kwds : %{ } } } but if we do so we must oblige iex(8)&gt; parse ( ~W[value: xxx] , optional : [ value : :int ] ) { :error , %{ args : [ ] , kwds : %{ value : &quot;xxx&quot; } , errors : [ { :bad_constraint_int , :value , &quot;xxx&quot; } ] } } and constraints work for positionals too iex(9)&gt; parse ( ~W[10] , optional : [ { 0 , :int } ] ) { :ok , %{ args : [ 10 ] , kwds : %{ } } } iex(10)&gt; parse ( ~W[ten] , optional : [ { 0 , :int } ] ) { :error , %{ args : ~W[ten] , kwds : %{ } , errors : [ { :bad_constraint_int , 0 , &quot;ten&quot; } ] } } and as positionals are optional unless constrained with needed: this is ok iex(11)&gt; parse ( [ ] , optional : [ { 0 , :int } ] ) { :ok , %{ args : [ ] , kwds : %{ } } } Custom made constraints need either return {:ok, value} iex(12)&gt; always_42 = fn _ , _ -&gt; { :ok , 42 } end ...(12)&gt; parse ( ~W[value: hello!] , optional : [ value : always_42 ] ) { :ok , %{ args : [ ] , kwds : %{ value : 42 } } } or {:error, message} iex(13)&gt; never_happy = fn val , key -&gt; { :error , { :so_bad , key , &quot;must not have \#{ val } &quot; } } end ...(13)&gt; parse ( ~W[value: hello!] , optional : [ value : never_happy ] ) { :error , %{ args : [ ] , kwds : %{ value : &quot;hello!&quot; } , errors : [ { :so_bad , :value , &quot;must not have hello!&quot; } ] } } Memberships Ranges iex(14)&gt; int_range = &amp; ExAequo.SemanticClaParser.Constraints . int_range / 2 ...(14)&gt; parse ( ~W[42] , optional : [ { 0 , int_range . ( 41 , 43 ) } ] ) { :ok , %{ args : [ 42 ] , kwds : %{ } } } iex(15)&gt; int_range = &amp; ExAequo.SemanticClaParser.Constraints . int_range / 2 ...(15)&gt; parse ( ~W[420] , optional : [ { 0 , int_range . ( 41 , 43 ) } ] ) { :error , %{ args : ~W[420] , kwds : %{ } , errors : [ { :not_in_int_range , 0 , 420 , 41 .. 43 } ] } } iex(16)&gt; int_range = &amp; ExAequo.SemanticClaParser.Constraints . int_range / 2 ...(16)&gt; parse ( ~W[a] , optional : [ { 0 , int_range . ( 41 , 43 ) } ] ) { :error , %{ args : [ &quot;a&quot; ] , kwds : %{ } , errors : [ { :bad_constraint_int_range , 0 , &quot;a&quot; } ] } } Note that we cannot specify the nth positional argument as required, we can however constrain the number of positional argumentes iex(17)&gt; parse ( [ ] , needed : 0 .. 1 ) { :ok , %{ args : [ ] , kwds : %{ } } } iex(18)&gt; parse ( ~W[one] , needed : 0 .. 1 ) { :ok , %{ args : [ &quot;one&quot; ] , kwds : %{ } } } iex(19)&gt; parse ( ~W[:a one] , needed : 0 .. 1 ) { :ok , %{ args : [ &quot;one&quot; ] , kwds : %{ a : true } } } However iex(20)&gt; parse ( ~W[: :a one] , needed : 0 .. 1 ) { :error , %{ args : [ &quot;:a&quot; , &quot;one&quot; ] , kwds : %{ } , errors : [ { :illegal_number_of_args , 0 .. 1 , 2 } ] } } We can even forbid positionals like that iex(21)&gt; parse ( ~W[a] , needed : 0 ) { :error , %{ args : [ &quot;a&quot; ] , kwds : %{ } , errors : [ { :illegal_number_of_args , 0 .. 0 , 1 } ] } }","ref":"ExAequo.SemanticClaParser.html","title":"ExAequo.SemanticClaParser","type":"module"},{"doc":"","ref":"ExAequo.SemanticClaParser.html#parse/2","title":"ExAequo.SemanticClaParser.parse/2","type":"function"},{"doc":"A simple Command Line Argument Parser delivering syntactically but not semantically checked Commnad Line Arguments Nothing in → Nothing out iex(1)&gt; parse ( [ ] ) { :ok , %{ args : [ ] , kwds : %{ } } } Positionals only iex(2)&gt; parse ( ~W[alpha beta gamma] ) { :ok , %{ args : ~W[alpha beta gamma] , kwds : %{ } } } Flags are indicated by a leading : iex(3)&gt; parse ( ~W[:verbose :help alpha beta gamma] ) { :ok , %{ args : ~W[alpha beta gamma] , kwds : %{ verbose : true , help : true } } } Keywords needing values are defined à la json with a trailing : iex(4)&gt; parse ( ~W[level: 42 :h name: Elixir] ) { :ok , %{ args : ~W[] , kwds : %{ level : &quot;42&quot; , h : true , name : &quot;Elixir&quot; } } } A single : just ends keyword parsing iex(5)&gt; parse ( ~W[level: 42 : :h name: Elixir] ) { :ok , %{ args : ~W[:h name: Elixir] , kwds : %{ level : &quot;42&quot; } } } Beware of not giving values to keywords iex(6)&gt; parse ( ~W[level:] ) { :error , %{ args : [ ] , kwds : %{ } , error : &quot;Missing value for keyword arg level!&quot; } } iex(7)&gt; parse ( ~W[level: : high] ) { :error , %{ args : ~W[high] , kwds : %{ } , error : &quot;Missing value for keyword arg level!&quot; } }","ref":"ExAequo.SimpleClaParser.html","title":"ExAequo.SimpleClaParser","type":"module"},{"doc":"","ref":"ExAequo.SimpleClaParser.html#parse/1","title":"ExAequo.SimpleClaParser.parse/1","type":"function"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html","title":"ExAequo.SysInterface.Behavior","type":"behaviour"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#c:expand_path/1","title":"ExAequo.SysInterface.Behavior.expand_path/1","type":"callback"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#c:lstat/2","title":"ExAequo.SysInterface.Behavior.lstat/2","type":"callback"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#c:wildcard/2","title":"ExAequo.SysInterface.Behavior.wildcard/2","type":"callback"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#t:date_tuple/0","title":"ExAequo.SysInterface.Behavior.date_tuple/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#t:lstat_result/0","title":"ExAequo.SysInterface.Behavior.lstat_result/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#t:param_type/0","title":"ExAequo.SysInterface.Behavior.param_type/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#t:params_t/0","title":"ExAequo.SysInterface.Behavior.params_t/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Implementation.html","title":"ExAequo.SysInterface.Implementation","type":"module"},{"doc":"Callback implementation for ExAequo.SysInterface.Behavior.expand_path/1 .","ref":"ExAequo.SysInterface.Implementation.html#expand_path/1","title":"ExAequo.SysInterface.Implementation.expand_path/1","type":"function"},{"doc":"Callback implementation for ExAequo.SysInterface.Behavior.lstat/2 .","ref":"ExAequo.SysInterface.Implementation.html#lstat/2","title":"ExAequo.SysInterface.Implementation.lstat/2","type":"function"},{"doc":"Callback implementation for ExAequo.SysInterface.Behavior.wildcard/2 .","ref":"ExAequo.SysInterface.Implementation.html#wildcard/2","title":"ExAequo.SysInterface.Implementation.wildcard/2","type":"function"},{"doc":"","ref":"ExAequo.SysInterface.Implementation.html#t:date_tuple/0","title":"ExAequo.SysInterface.Implementation.date_tuple/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Implementation.html#t:lstat_result/0","title":"ExAequo.SysInterface.Implementation.lstat_result/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Implementation.html#t:param_type/0","title":"ExAequo.SysInterface.Implementation.param_type/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Implementation.html#t:params_t/0","title":"ExAequo.SysInterface.Implementation.params_t/0","type":"type"},{"doc":"","ref":"ExAequo.Types.html","title":"ExAequo.Types","type":"module"}]